<?php
use Carbon_Fields\Container;
use Carbon_Fields\Field;
class Sejoli_Mailketing {

	/**
	 * mailketing API Key
	 *
	 * @var string
	 */
	public $api_key;


	/**
	 * Convert kit account tags
	 *
	 * @var object
	 */
	public $tags;

	/**
	 * Sets up the checkout label
	 */

   protected $menu_position = 1;

    /**
     * Registered point member menu list
     * @since   1.0.0
     * @var     array
     */
    protected $member_menu = array();
	function __construct() {
    $options = get_option( "mailketingsmtp_options" );
    $this->member_menu =  array(
       'link' => site_url('member-area/mailketing-int'),
       'label' => __('Mailketing Intargrasi','sejoli'),
       'icon' => '',
       'class' => 'item',
       'submenu' => array()
     );
    add_filter('sejoli/product/fields', array( $this, 'product_menu' ));
    add_action('sejoli/order/new', array( $this, 'new_order' ));
    add_action('sejoli/order/set-status/completed', array( $this, 'complete_order' ));
    add_filter('sejoli/member-area/menu', array( $this, 'register_menu' ));
    add_filter('sejoli/member-area/backend/menu', array( $this, 'be_menu_mailketing' ));
    add_filter('sejoli/template-file', array( $this, 'set_template_file' ),10,2);
    add_filter( 'sejoli/member-area/menu-link',	array( $this, 'display_link_list_in_menu' ), 12, 4);
    add_action( 'wp_enqueue_scripts', array( $this, 'mailketing_enqueue' ) );
    add_action( 'wp_ajax_check_mailketing', array( $this, 'check_mailketing_aff' ) );
    add_action( 'wp_ajax_nopriv_check_mailketing', array( $this, 'check_mailketing_aff' ) );
    add_action( 'wp_ajax_check_mailketing_product', array( $this, 'check_mailketing_aff_product' ) );
    add_action( 'wp_ajax_nopriv_check_mailketing_product', array( $this, 'check_mailketing_aff_product' ) );
    add_action( 'wp_ajax_update_lead_product', array( $this, 'update_lead_product' ) );
    add_action( 'wp_ajax_nopriv_update_lead_product', array( $this, 'update_lead_product' ) );
    add_action( 'wp_ajax_update_purchase_product', array( $this, 'update_purchase_product' ) );
    add_action( 'wp_ajax_nopriv_update_purchase_product', array( $this, 'update_purchase_product' ) );
	}
  function mailketing_enqueue() {
    $theme_url  = plugin_dir_path(__FILE__);     // Used to keep our Template Directory URL
    $ajax_url   = admin_url( 'admin-ajax.php' );        // Localized AJAX URL
    wp_register_script(
        'mk-modifications',                             // Our Custom Handle
        "/wp-content/plugins/mailketing-smtp/js/mailketing.js",  // Script URL, this script is located for me in `theme-name/scripts/um-modifications.js`
        array( 'jquery' ),                              // Dependant Array
        '1.0',                                          // Script Version ( Arbitrary )
        true                                            // Enqueue in Footer
    );

    // Localize Our Script so we can use `ajax_url`
    wp_localize_script(
        'mk-modifications',
        'mlk',array('ajax_url' =>$ajax_url)
    );
    // Finally enqueue our script
    wp_enqueue_script( 'mk-modifications' );
}

  function check_mailketing_aff() {
    if( ! isset( $_POST ) || empty( $_POST ) || ! is_user_logged_in() ) {
        header( 'HTTP/1.1 400 Empty POST Values' );
        echo 'Could Not Verify POST Values.';
        exit;
    }

    $user_id        = get_current_user_id();
    $email         = sanitize_text_field( $_POST['email'] );
    update_user_meta( $user_id, '_mailketing_token', $email );
    exit;
  }

  function update_lead_product() {
    if( ! isset( $_POST ) || empty( $_POST ) || ! is_user_logged_in() ) {
        header( 'HTTP/1.1 400 Empty POST Values' );
        echo 'Could Not Verify POST Values.';
        exit;
    }

    $user_id        = get_current_user_id();
    $product_id         = sanitize_text_field( $_POST['product_id'] );
    $list_id=sanitize_text_field( $_POST['list_id'] );
    update_post_meta( $product_id, '_lead_mlk_'.$user_id, $list_id );
  }
  function update_purchase_product() {
    if( ! isset( $_POST ) || empty( $_POST ) || ! is_user_logged_in() ) {
        header( 'HTTP/1.1 400 Empty POST Values' );
        echo 'Could Not Verify POST Values.';
        exit;
    }
    $user_id        = get_current_user_id();
    $product_id         = sanitize_text_field( $_POST['product_id'] );
    $list_id=sanitize_text_field( $_POST['list_id'] );
    update_post_meta( $product_id, '_purchase_mlk_'.$user_id, $list_id );
  }
  function check_mailketing_aff_product() {
    if( ! isset( $_POST ) || empty( $_POST ) || ! is_user_logged_in() ) {
        header( 'HTTP/1.1 400 Empty POST Values' );
        echo 'Could Not Verify POST Values.';
        exit;
    }

    $user_id        = get_current_user_id();
    $product_lead = get_post_meta($_POST['product_id'],'_lead_mlk_'.$user_id,true);
    $product_purchase =get_post_meta($_POST['product_id'],'_purchase_mlk_'.$user_id,true);
    if(!$product_lead){
    $product_lead=0;
    }
    if(!$product_purchase){
      $product_purchase=0;
    }
    $res["status"] = true;
    $res["product_purchase"] = $product_purchase;
    $res["product_lead"] = $product_lead;
    echo json_encode($res);
    die();
    //update_user_meta( $user_id, '_mailketing_token', $email );

  }
  public function be_menu_mailketing(array $menu) {
    $point_menu = array(
        'title'  => __('Mailketing Integration', 'sejoli'),
        'object' => 'sejoli-mailketing',
        'url'    => site_url('member-area/mailketing-int')
    );

    // Add point menu in selected position
    $menu   =   array_slice($menu, 0, $this->menu_position, true) +
                array('sejoli-mailketing' => $point_menu) +
                array_slice($menu, $this->menu_position, count($menu) - 1, true);

    return $menu;
    }

  public function register_menu(array $menu) {
    $menu = array_slice($menu, 0, $this->menu_position, true) +
                array( 'sejoli-mailketing' => $this->member_menu ) +
                array_slice($menu, $this->menu_position, count($menu) - 1, true);
        return $menu;
  }

  public function display_link_list_in_menu($output, $object, $args, $setup) {

        if('sejoli-mailketing' === $object->object) :
            // YES IM LAZY
            extract($args);

            ob_start();
            ?>

            <div class="master-menu">
                <a href="<?php echo  $this->member_menu['link']?>;" class='item'>
                    <i class='envelope icon'></i>
                    <?php echo $object->post_title; ?>
                </a>
            </div>
            <?php

            $item_output = ob_get_contents();
            ob_end_clean();

            return $item_output;
        endif;

        return $output;
    }



  function product_menu(array $fields) {
        $options = get_option( "mailketingsmtp_options" );
				$fields[] = [
			'title'	=> __('Mailketing', 'sejoli_mailketing'),
						'fields' =>  [
				Field::make('separator', 'sep_mailketing', __('Integrasi Mailketing', 'sejoli')),
          Field::make( 'select', 'order_list_product', __( 'Pilih List untuk Menyimpan Data Order' ) )
    ->set_options( $this->get_lists($options['mailketingsmtp_api']) ),
    Field::make( 'select', 'completed_list_product', __( 'Pilih List untuk Menyimpan Data Complete Order' ) )
->set_options( $this->get_lists($options['mailketingsmtp_api']) ),
						]
				];

				return $fields;
		}


    /**
     * Set template file for point menu template
     * Hooked via sejoli/template-file, priority 122
     * @since   1.0.0
     * @param   string  $file
     * @param   string  $view_request
     */
    public function set_template_file(string $file, string $view_request) {

        if('mailketing-int' === $view_request) :

            return EDD_mailketing_PATH . '/template/mailketing-aff.php';

        endif;

        return $file;
    }
    function new_order($order_data) {
      $product_id=$order_data['product_id'];
      $aff_id=$order_data['affiliate_id'];
      $user_id=$order_data['user_id'];
      $product_meta=get_post_meta($product_id,'_order_list_product',true);
      if($product_meta){
        $options = get_option( "mailketingsmtp_options" );
        $hasil=$this->subscribe( $user_id,$product_meta,$options['mailketingsmtp_api'] );
      }
      $product_meta_aff=get_post_meta($product_id,'_lead_mlk_'.$aff_id,true);
      if($product_meta_aff){
        $api_token=get_user_meta($aff_id,'_mailketing_token',true);
        $hasil=$this->subscribe( $user_id, $product_meta_aff,$api_token);
      }
      return $order_data;
    }
    function complete_order($order_data) {
      $product_id=$order_data['product_id'];
      $aff_id=$order_data['affiliate_id'];
      $user_id=$order_data['user_id'];
      $product_meta=get_post_meta($product_id,'_completed_list_product',true);
      if($product_meta){
        $options = get_option( "mailketingsmtp_options" );
        $hasil=$this->subscribe( $user_id, $product_meta,$options['mailketingsmtp_api'] );
      }
      $product_meta_aff=get_post_meta($product_id,'_purchase_mlk_'.$aff_id,true);
      if($product_meta_aff){
        $api_token=get_user_meta($aff_id,'_mailketing_token',true);
        $hasil=$this->subscribe( $user_id, $product_meta_aff,$api_token);
      }


      return $order_data;
    }
    public function get_lists($api_token) {
      if(!isset($api_token) || $api_token==''){
        return array();
      }
      $url='https://api.mailketing.co.id/API/getLists';
      $response = wp_remote_get( $url, array(
          'APIToken'    => $api_token,
          'headers' => array(
              'APIToken' => $api_token,
          ),
      ) );

      $ua=wp_remote_retrieve_body($response);
      $has = json_decode($ua,true);

  			if( ! empty( $has['response']['list'] ) || isset($has['response']['list'])) {
					$lists=$has['response']['list'];
  				foreach( $lists as $list ) {
  					$this->lists[ $list['list_id'] ] = $list['list_name'];
  				}
  			}
		if(isset($this->lists)){
return (array) $this->lists;
}else{
return array();
}
  		return (array) $this->lists;
  	}
    public function subscribe( $user_id, $list_id,$api_token ) {
  		if( ! $list_id ) {
  				return false;
  		}
      if( ! $api_token ) {
  				return false;
  		}
      if( ! $user_id ) {
  				return false;
  		}
      $user      = get_userdata( $user_id );
  		$user_meta = get_user_meta( $user_id,'_phone',true );

      $first_name=$user->display_name;
      $email=$user->user_email;
      $mobile=$user_meta;
        $url='https://api.mailketing.co.id/api/v1/addsubtolist';
        $args = array(
            'method' => 'POST',
            'timeout' => '10',
                'blocking' => false,
            'headers'  => array(
                'Content-type: application/x-www-form-urlencoded'
            ),
            'sslverify' => true,
            'body' => array(
              'first_name'    => $first_name,
              'email'    => $email,
  						'mobile'	=> $mobile,
              'api_token'    => $api_token,
              'list_id'	=> $list_id
            )
        );
        $response = wp_remote_post( $url,$args);
        $response=wp_remote_retrieve_body($response);
  		return true;
  	}
}
  ?>
